"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.loadModules = void 0;

var _promise = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/promise"));

var _interopRequireWildcard2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/interopRequireWildcard"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/asyncToGenerator"));

// let modules = [{
//     name: 'passport',
//     options: {
//         url: 'passport',
//         default: true,
//         moduleName: 'passport'
//     }
// }, {
//     name: 'cors',
//     options: {
//         url: 'cors',
//         default: false,
//         moduleName: 'cors'
//     }
// }]
function* modulesIterator(modules) {
  yield* modules;
}

var loadModules = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2.default)(function* (modules) {
    var module = {};
    var moduleName = '';
    var importedModulesObjects = {};

    try {
      var it = modulesIterator(modules);
      var totalModules = modules.length;

      while (totalModules > 0) {
        module = it.next().value;
        moduleName = module.options.moduleName;
        importedModulesObjects[moduleName] = {};
        importedModulesObjects[moduleName].promise = _promise.default.resolve("".concat(module.options.url)).then(s => (0, _interopRequireWildcard2.default)(require(s)));
        importedModulesObjects[moduleName].options = module.options;
        console.log('after promise gen');
        totalModules--;
      }

      console.log('after promise gen while');

      for (var importedModulesObject in importedModulesObjects) {
        var importDefault = importedModulesObjects[importedModulesObject].options.default;
        var importedModule = yield importedModulesObjects[importedModulesObject].promise;

        if (importDefault) {
          importedModulesObjects[importedModulesObject].resolved = importedModule.default;
        } else {
          importedModulesObjects[importedModulesObject].resolved = importedModule;
        }

        importedModulesObjects[importedModulesObject] = importedModulesObjects[importedModulesObject].resolved;
        delete importedModulesObjects[importedModulesObject].resolved;
        delete importedModulesObjects[importedModulesObject].promise;
        delete importedModulesObjects[importedModulesObject].options;
      }

      return importedModulesObjects;
    } catch (err) {
      throw err;
    }
  });

  return function loadModules(_x) {
    return _ref.apply(this, arguments);
  };
}(); // {
//     url: 'passport',
//     options: {
//         default: true,
//         moduleName: 'passport'
//     }
// }
// loadModule(modules).then(rsp => {
//     console.log('rsp: ', rsp);
// })
// export const loadmodule = async () => {
//     modules.map(module => {
//     })
//     // return [{
//     //         default: passport
//     //     },
//     //     {
//     //         default: passportInit
//     //     }
//     // ] = await Promise.all([
//     //     await import('passport'),
//     //     import('./configs/passport.config')
//     // ])
// }


exports.loadModules = loadModules;
